/*
  INF3105 - Structures de données et algorithmes
  UQAM / Département d'informatique

  Lab5
  Programme pour générer des tests aléatoirement.
*/

#include <cstdlib>
#include <iostream>
#include <random>

using namespace std;

int main(int argc, const char** argv) {
  int nbpassages = 100000;
  int nbcartes = 10000;
  double delaimoyen = 1.0;

  if (argc > 1) nbpassages = atoi(argv[1]);
  if (argc > 2) nbcartes   = atoi(argv[2]);
  if (argc > 3) delaimoyen = atof(argv[3]);

  random_device rd;
  mt19937 gen(rd());
  exponential_distribution<> dist2(1 / delaimoyen);
  uniform_int_distribution<> dist10000( 0, nbcartes - 1);

  double time = 0;
  for (int i = 0; i < nbpassages; i++) {
    const double dt = dist2(gen);
    const int carte = dist10000(gen);

    time += dt;

    cout << (int) time << "\t" << (10000 + carte) << endl;
  }
}
